@echo off

setlocal EnableExtensions
setlocal EnableDelayedExpansion

@echo "--------------------------------- >>"

set tmp_file="%TEMP%\sm_file_send_install.dat"

if exist %tmp_file% (
	del /F %tmp_file%
)

set curr_path=%~dp0..\..\..

@echo "ProgramFiles      = %ProgramFiles%";
@echo "ProgramFiles(x86) = %ProgramFiles(x86)%";

@echo "ALLUSERSPROFILE   = %ALLUSERSPROFILE%";
@echo "PROGRAMDATA    	 = %PROGRAMDATA%";
@echo "LOCALAPPDATA 	 = %LOCALAPPDATA%";
@echo "APPDATA      	 = %APPDATA%";

set trg_path=%ALLUSERSPROFILE%\smansoft
set trg_path_res=0
if exist "%trg_path%" (
	goto install
) else (
	mkdir "%trg_path%" && set trg_path_res=1
)

if %trg_path_res% == 0 (
	set trg_path=%LOCALAPPDATA%\smansoft
	set trg_path_res=0
	if exist "!trg_path!" (
		goto install
	) else (
		mkdir "!trg_path!" && set trg_path_res=1
	)
)

if %trg_path_res% == 0 (
	set trg_path=%APPDATA%\smansoft
	set trg_path_res=0
	if exist "!trg_path!" (
		goto install
	) else (
		mkdir "!trg_path!" && set trg_path_res=1
	)
)

if %trg_path_res% == 0 (
	exit /B 0
)

:install

set curr_path=%~dp0..\..\..

@echo curr_path	= %curr_path%
@echo trg_path  = %trg_path%"

set sm_file_send_w=%trg_path%\sm_file_send_w

set cln_out=%sm_file_send_w%\cln_out
set cln_backups=%sm_file_send_w%\cln_backups

set srv_in=%sm_file_send_w%\srv_in
set srv_backups=%sm_file_send_w%\srv_backups

set common_path=%trg_path%\common

set clns_common_path=%common_path%\sm_file_send_clns.xml
set srvs_common_path=%common_path%\sm_file_send_srvs.xml

set cln_common_path=%common_path%\sm_file_send_cln.xml
set srv_common_path=%common_path%\sm_file_send_srv.xml

set clns_path=%trg_path%\sm_file_send_clns\sm_file_send_clns.xml
set srvs_path=%trg_path%\sm_file_send_srvs\sm_file_send_srvs.xml

set cln_path=%trg_path%\sm_file_send_cln\sm_file_send_cln.xml
set srv_path=%trg_path%\sm_file_send_srv\sm_file_send_srv.xml

call :create_dir "%trg_path%\sm_file_send_cln"
call :create_dir "%trg_path%\sm_file_send_clns"
call :create_dir "%trg_path%\sm_file_send_srv"
call :create_dir "%trg_path%\sm_file_send_srvs"

call :create_dir "%trg_path%\sm_file_send_srvs"

call :create_dir "%common_path%"

call :create_dir "%sm_file_send_w%"

call :create_dir "%cln_backups%"
call :create_dir "%cln_out%"
call :create_dir "%srv_backups%"
call :create_dir "%srv_in%"

echo Creating of directories is finished...

call :copy_dir "%curr_path%\share\smansoft\sm_file_send_cln"  "%trg_path%\sm_file_send_cln"
call :copy_dir "%curr_path%\share\smansoft\sm_file_send_clns" "%trg_path%\sm_file_send_clns"
call :copy_dir "%curr_path%\share\smansoft\sm_file_send_srv"  "%trg_path%\sm_file_send_srv"
call :copy_dir "%curr_path%\share\smansoft\sm_file_send_srvs" "%trg_path%\sm_file_send_srvs"

echo Copying of directories is finished...

call :create_clns_config %clns_common_path% %cln_out% %cln_backups%
call :create_srvs_config %srvs_common_path% %srv_in% %srv_backups%

call :create_empty_config %cln_common_path%
call :create_empty_config %srv_common_path%

call :create_empty_config %clns_path%
call :create_empty_config %cln_path%

call :create_empty_config %srvs_path%
call :create_empty_config %srv_path%

echo Creating of configuration files is finished...

echo "temp" >> %tmp_file% 

@echo "--------------------------------- <<"

exit /B 0

:create_empty_config

echo Create Empty Config: %~1

set "tag_line=<config>"
echo !tag_line!	>  "%~1"

set "tag_line=</config>"
echo !tag_line!	>> "%~1"

exit /B 0

:create_clns_config

echo Create Clns Config: %~1

set "tag_line=<config>"
echo !tag_line!	> "%~1"

set "tag_line=	<control_code>1</control_code>"
echo !tag_line!	>> "%~1"

set "tag_line=	<op_code>1</op_code>"
echo !tag_line!	>> "%~1"

set "tag_line=	<out_dir>%2</out_dir>"
echo !tag_line!	>> "%~1"

set "tag_line=	<back_dir>%3</back_dir>"
echo !tag_line!	>> "%~1"

set "tag_line=	<file></file>"
echo !tag_line!	>> "%~1"

set "tag_line=	<server_address>127.0.0.1</server_address>"
echo !tag_line!	>> "%~1"

set "tag_line=	<server_port>22223</server_port>"
echo !tag_line!	>> "%~1"

set "tag_line=	<use_ssl>true</use_ssl>"
echo !tag_line!	>> "%~1"

set "tag_line=	<sub_dirs>true</sub_dirs>"
echo !tag_line!	>> "%~1"

set "tag_line=	<scan_time>1000</scan_time>"
echo !tag_line!	>> "%~1"

set "tag_line=</config>"
echo !tag_line!	>> "%~1"

exit /B 0

:create_srvs_config
echo Create Srvs Config: %~1

set "tag_line=<config>"
echo !tag_line!	>  "%~1"

set "tag_line=	<control_code>1</control_code>"
echo !tag_line!	>> "%~1"

set "tag_line=	<in_dir>%~2</in_dir>"
echo !tag_line!	>> "%~1"

set "tag_line=	<back_dir>%~3</back_dir>"
echo !tag_line!	>> "%~1"

set "tag_line=	<port>22222</port>"
echo !tag_line!	>> "%~1"

set "tag_line=	<ssl_port>22223</ssl_port>"
echo !tag_line!	>> "%~1"

set "tag_line=</config>"
echo !tag_line!	>> "%~1"

exit /B 0

:create_dir
echo Create Directory: %~1
if not exist "%~1" (
	md "%~1"
)
exit /B 0

:copy_dir
echo Copy Directory:
echo From: %~1 
echo To: %~2 
if exist "%~1" (
	if exist "%~2" (
		xcopy "%~1" "%~2" /E /Y
	)
)
exit /B 0
